SystemOrganization addCategory: #'CS520-HomeAutomation'!

RectangleMorph subclass: #HomeAutomationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationView subclass: #DeviceView
	instanceVariableNames: 'device label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!DeviceView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:20'!
createFromDevice: aDevice
	| newDeviceView |
	newDeviceView := DeviceView new.
	newDeviceView setDevice: aDevice.
	^ newDeviceView.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:55'!
device
	^ device! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:00'!
isDeviceView
	^ true! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:02'!
justDroppedInto: aPotentialRoomView event: anEvent
	super justDroppedInto: aPotentialRoomView event: anEvent.
	(aPotentialRoomView isRoomView) ifTrue: [ self device attachTo: aPotentialRoomView room ].! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:35'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	formerOwner isRoomView
		ifTrue: [ self device detachFromRoom ]! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:16'!
modelUpdated: aStatusMessage
	self updateViewFromModel.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
resetViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:30'!
setDevice: aDevice 
	device := aDevice.
	device when: #updated send: #modelUpdated: to: self with: #statusMessage.
	self resetViewFromModel.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:03'!
setLabelProperties
	| newLabel |
	newLabel := StringMorph new.
	newLabel contents: device name.
	newLabel color: (Color black orColorUnlike: self color).
	self borderColor: newLabel color.
	label isNil
		ifTrue: [ 
			self addMorphCentered: newLabel.
			label := newLabel ]! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:54'!
setViewProperties
	self width: device width.
	self height: device height.
	self color: device color.
	! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 14:02'!
updateViewFromModel
	self setViewProperties.
	self setLabelProperties.! !

DeviceView subclass: #ObserverDeviceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!ObserverDeviceView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:27'!
createFromDevice: aDevice
	| newDeviceView |
	newDeviceView := ObserverDeviceView new.
	newDeviceView setDevice: aDevice.
	^ newDeviceView.! !

!ObserverDeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:26'!
modelUpdated: statusMessage
	| balloonTextStream |
	super modelUpdated: statusMessage.
"	balloonTextStream := TextStream with: ''.
	self device usersTracked do: [ :each | balloonTextStream << each name << ' is in the ' << each room name.  balloonTextStream cr ]."
	"self showBalloon: balloonTextStream contents."
	Transcript show: statusMessage; cr.! !

!HomeAutomationView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:34'!
isHomeAutomationView
	^ true! !

HomeAutomationView subclass: #RoomView
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 21:18'!
createFromRoom: aRoom
	^ RoomView createFromRoom: aRoom withColor: RoomView defaultColor.! !

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 21:16'!
createFromRoom: aRoom withColor: aColor
	| newRoomView |
	newRoomView := RoomView new.
	newRoomView setRoom: aRoom.
	newRoomView color: aColor.
	^ newRoomView.! !

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 21:17'!
defaultColor
	^ Color gray! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:49'!
installDevice: each atPosition: currPosition
	| newDeviceView |
	newDeviceView := DeviceView createFromDevice: each.
	newDeviceView position: currPosition.
	self addMorphFront: newDeviceView.
	^ newDeviceView! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:49'!
installDevices
	| currPosition hGap vGap |
	hGap := 5.
	vGap := 5.
	currPosition := hGap @ vGap.
	room attachedDevices
		do: [ :each | 
			| newDeviceView |
			self width > (currPosition x + each width + hGap)
				ifTrue: [ 
					newDeviceView := self installDevice: each atPosition: currPosition.
					currPosition := currPosition + ((newDeviceView width + hGap) @ 0) ] ]! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:54'!
isRoomView
	^ true! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:44'!
repelsMorph: aMorph event: ev
	^ (self wantsDroppedMorph: aMorph event: ev) not! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:22'!
resetViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	self installDevices.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:02'!
room
	^ room! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: room name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
setRoom: aRoom
	room := aRoom.
	self resetViewFromModel.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 21:19'!
setViewProperties
	self width: room width.
	self height: room height.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:10'!
updateViewFromModel
	self
		submorphsDo: [ :aSubMorph | 
			aSubMorph isHomeAutomationView
				ifTrue: [ aSubMorph updateViewFromModel ] ].
	self setViewProperties.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:01'!
wantsDroppedMorph: aMorph event: anEvent
	^ (aMorph isUserView) | (aMorph isDeviceView)! !

HomeAutomationView subclass: #UserView
	instanceVariableNames: 'user speakButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!UserView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:58'!
createFromUser: aUser
	^ UserView createFromUser: aUser withColor: UserView defaultColor.! !

!UserView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 18:02'!
createFromUser: aUser withColor: aColor
	| newUserView |
	newUserView := UserView new.
	newUserView setColor: aColor.
	newUserView setUser: aUser.
	^ newUserView.! !

!UserView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:53'!
defaultColor
	^ Color blue! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:14'!
initialize
	super initialize.
	speakButton := SimpleButtonMorph newWithLabel: 'speak'.
	speakButton target: self; actionSelector: #speakButtonPressed.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:48'!
isUserView
	^ true! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:23'!
justDroppedInto: aPotentialRoomView event: anEvent
	super justDroppedInto: aPotentialRoomView event: anEvent.
	(aPotentialRoomView isRoomView) ifTrue: [ self user enterRoom: aPotentialRoomView room ].
	! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:25'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	(formerOwner isRoomView) ifTrue: [ self user exitCurrentRoom ].! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:14'!
resetViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	self setSpeakProperties.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:52'!
setColor: aColor
	color := aColor.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 18:03'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: user name.
	label color: (Color yellow orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:14'!
setSpeakProperties
	self addMorphCentered: speakButton.
	speakButton position: (speakButton position + (0@25)).! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
setUser: aUser
	user := aUser.
	self resetViewFromModel.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:16'!
setViewProperties
	self width: 55.
	self height: 80.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:17'!
speakButtonPressed
	| dialog |
	dialog := TextEditorDialogWindow new.
	dialog title: 'Type a message to speak'.
	self openModal: dialog.
	dialog entryText ifNotNil: [ user speak: dialog entryText ].! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:05'!
updateViewFromModel
"	self setViewProperties.
	self setLabelProperties."! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:54'!
user
	^ user! !

TestCase subclass: #HomeAutomationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 19:48'!
setUp! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:41'!
testAttachDeviceToRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test'.
	device := Camera new.
	device attachTo: room.
	
	self assert: (room hasDevice: device).
	self assert: (device isAttachedTo: room).
	self assert: (device isAttachedToARoom).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:20'!
testCreateCameraSensor
	| camera |
	camera := Camera createWithName: 'Camera 01'.
	self assert: (camera name = 'Camera 01').
	self assert: (camera size = (30@30)).
	self assert: (camera color = Color black).
	self assert: (camera height = 30).
	self assert: (camera width = 30).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:30'!
testCreateRoom
	| room |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	self assert: (room name = 'Kitchen').
	self assert: (room width = 50).
	self assert: (room height = 100).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:56'!
testCreateUser
	| user |
	user := User createWithName: 'simon'.
	self assert: (user name = 'simon').
	self assert: (user room = Room noneRoom).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:41'!
testDetachDeviceFromRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test'.
	device := Camera new.
	device attachTo: room.
	device detachFromRoom.
	self deny: (room hasDevice: device).
	self deny: (device isAttachedTo: room).
	self assert: (device isAttachedTo: Room noneRoom).
	self deny: (device isAttachedToARoom).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:30'!
testObserverDoesNotGetNotfiedOfUserEntry
	| room device user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := DummyDevice new.
	device attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: device.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	self deny: (observer detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:30'!
testObserverDoesNotGetNotfiedOfUserExitAfterStopsObserving
	| room device user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: device.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	observer stopObserving: device.
	user exitCurrentRoom.
	self assert: (observer detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:30'!
testObserverGetsNotfiedOfUserEntry
	| room device user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: device.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	self assert: (observer detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:30'!
testObserverGetsNotfiedOfUserEntryWithRoom
	| room device user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: device.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	self assert: (observer detectedUser: user).
	self assert: ((user room) = room)! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:31'!
testObserverGetsNotfiedOfUserExit
	| room device user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: device.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	self assert: (observer detectedUser: user).
	self assert: (user room = room).
	user exitCurrentRoom.
	self deny: (observer detectedUser: user).
	self assert: (user room = Room noneRoom).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:12'!
testUserEntersRoom
	| room user |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
"	room addUser: user."
	self assert: (room includesUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:32'!
testUserEntersRoomBeforeDevicesAttached
	| room user device observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	user enterRoom: room.

	device := Camera new.
	observer := HomeAutomationObserver new.
	observer observe: device.
	device attachTo: room.
	self assert: (observer detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:02'!
testUserSpeaks
	| room microphone user observer |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	microphone := Microphone createWithName: 'M1'.
	microphone attachTo: room.
	observer := HomeAutomationObserver new.
	observer observe: microphone.
	user := User createWithName: 'Tom'.
	user enterRoom: room.
	user speak: 'hello everyone!!'.
	self assert: (observer hasHeard: 'hello everyone!!' from: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:24'!
testUserSpeaksInRoomWithoutMicrophone
	| kitchen livingRoom microphone user observer |
	kitchen := Room createWithSize: 50@100 withName: 'Kitchen'.
	livingRoom := Room createWithSize: 50@100 withName: 'Living Room'.
	microphone := Microphone createWithName: 'M1'.
	microphone attachTo: kitchen.
	observer := HomeAutomationObserver new.
	observer observe: microphone.
	user := User createWithName: 'Tom'.
	user enterRoom: livingRoom.
	user speak: 'hello everyone!!'.
	self deny: (observer hasHeard: 'hello everyone!!' from: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:28'!
testUserSpeaksInRoomWithoutMicrophoneAfterLeaving
	| kitchen livingRoom microphone user observer |
	kitchen := Room createWithSize: 50@100 withName: 'Kitchen'.
	livingRoom := Room createWithSize: 50@100 withName: 'Living Room'.
	microphone := Microphone createWithName: 'M1'.
	microphone attachTo: kitchen.
	observer := HomeAutomationObserver new.
	observer observe: microphone.
	user := User createWithName: 'Tom'.
	user enterRoom: kitchen.
	user exitCurrentRoom.
	user enterRoom: livingRoom.
	user speak: 'hello everyone!!'.
	self deny: (observer hasHeard: 'hello everyone!!' from: user).! !

Object subclass: #HomeAutomationDevice
	instanceVariableNames: 'handledEvents room name size color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #DummyDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/10/2013 00:04'!
attachTo: aRoom
	room := aRoom.
	aRoom addDevice: self.
	self observeRoom: aRoom.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
color
	^ color! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
color: aColor
	color := aColor.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:35'!
detachFromRoom
	room removeDevice: self.
	self stopObservingRoom: room.
	room := Room noneRoom.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:36'!
handleEvent: anEvent with: messageParamAssoc
	handledEvents at: anEvent put: messageParamAssoc.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:38'!
handlesEvent: anEvent
	^ handledEvents includes: anEvent! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
height
	^ size y! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:22'!
initialize
	super initialize.
	handledEvents := Dictionary new.
	room := Room noneRoom.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 13:40'!
isAttachedTo: aRoom 
	^ room = aRoom! !

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/11/2013 13:40'!
isAttachedToARoom
	^ (room = Room noneRoom) not.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 15:00'!
listenTo: aDevice forEvent: anEvent
	self halt.
	(self handlesEvent: anEvent)
		ifTrue: [ 
			| message param |
			message := self messageForEvent: anEvent.
			param := self paramForEvent: anEvent.
			aDevice
				when: anEvent
				send: message
				to: self
				with: param ]! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 17:13'!
name 
	^ name! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:12'!
name: aByteString 
	name := aByteString.! !

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/10/2013 00:04'!
observeRoom: aRoom
	handledEvents
		associationsDo: [ :assoc | 
			| event message value |
			event := assoc key.
			message := assoc value key.
			value := assoc value value.
			aRoom
				when: event
				send: message
				to: self
				with: value ]! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 17:13'!
size
	^ size! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:13'!
size: aSize
	size := aSize.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:59'!
stopObservingRoom: aRoom 
	aRoom removeActionsWithReceiver: self.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 15:04'!
userEnteredMessage
	^ (Association new) key: #userEntered: value: #aUser.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 15:04'!
userExitedMessage
	^ (Association new) key: #userExited: value: #aUser.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 11:19'!
userSpokeMessage
	^ (Association new) key: #userSpoke: value: #userAndWords.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:12'!
width
	^ size x! !

HomeAutomationDevice subclass: #HomeAutomationObserver
	instanceVariableNames: 'usersTracked speechLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationObserver class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:23'!
createWithName: aName
	| newObserver |
	newObserver := HomeAutomationObserver new.
	newObserver name: aName.
	^ newObserver.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:17'!
defaultColor
	^ Color lightBlue! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 13:26'!
detectedUser: aUser 
	^ usersTracked includes: aUser.	
! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/11/2013 15:17'!
hasHeard: words from: aUser 
	^ (speechLog at: aUser ifAbsent: [ ^ false ]) includes: words.! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/11/2013 15:17'!
initialize
	super initialize.
	usersTracked := Set new.
	speechLog := Dictionary new.
	self color: (self defaultColor).
	self size: 30@30.
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:03'!
isTrackingUsers
	^ (usersTracked size > 0)! !

!HomeAutomationObserver methodsFor: 'associating' stamp: 'CameronRieck 3/11/2013 11:23'!
observe: aDevice
	aDevice when: #userEntered send: #userEntered: to: self with: #aUser.
	aDevice when: #userExited send: #userExited: to: self with: #aUser.
	aDevice when: #userSpoke send: #userSpoke: to: self with: #userAndWords.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:04'!
speechLog
	^ speechLog
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:55'!
stopObserving: aDevice
	aDevice removeActionsWithReceiver: self. 
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:23'!
userEntered: aUser
	| statusMessage |
	usersTracked add: aUser.
	self color: Color yellow. "TODO: should be in the view"
	statusMessage := aUser name , ' entered the ' , aUser room name.
	self triggerEvent: #updated with: statusMessage.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:30'!
userExited: aUser
	| statusMessage |
	(usersTracked includes: aUser) ifTrue: [ usersTracked remove: aUser ].
	(self isTrackingUsers) ifFalse: [ self color: (self defaultColor) ]. "TODO should be in the view"
	statusMessage := aUser name , ' exited the ' , aUser room name.
	self triggerEvent: #updated with: statusMessage.
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:30'!
userSpoke: userAndWords
	| logEntry statusMessage user words |
	user := userAndWords key.
	words := userAndWords value.
	logEntry := speechLog at: user ifAbsent: [ speechLog at: user put: (LinkedList new) ].
	logEntry add: words.
	statusMessage := user name , ' said ' , words , ' in the ' , user room name.
	self triggerEvent: #updated with: statusMessage.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 14:23'!
usersTracked
	^ usersTracked
	! !

HomeAutomationDevice subclass: #HomeAutomationSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationSensor subclass: #Camera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Camera class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:02'!
createWithName: aName
	| newCamera |
	newCamera := Camera new.
	newCamera name: aName.
	^ newCamera.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:57'!
attachTo: aRoom
	"We must simulate a user entering a room when the camera is installed in a room when users are already present.
	Otherwise, interested observers will not know who is in the room until they come back in."
	super attachTo: aRoom.
	aRoom usersPresent do: [ :each | self userEntered: each ].! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 15:05'!
initialize
	super initialize.
	self size: 30@30.
	self color: Color black.
	self handleEvent: #userEntered with: (self userEnteredMessage).
	self handleEvent: #userExited with: (self userExitedMessage).! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 15:05'!
userEntered: aUser
	self triggerEvent: #userEntered with: aUser.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:29'!
userExited: aUser
	self triggerEvent: #userExited with: aUser.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:01'!
initialize
	super initialize.
	name := ''.
	size := 0@0.
	color := Color white.! !

HomeAutomationSensor subclass: #Microphone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Microphone class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 16:01'!
createWithName: aName
	| newMicrophone |
	newMicrophone := Microphone new.
	newMicrophone name: aName.
	^ newMicrophone.! !

!Microphone methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 15:58'!
initialize
	super initialize.
	self size: 30@30.
	self color: Color brown.
	self handleEvent: #userSpoke with: (self userSpokeMessage).! !

!Microphone methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/11/2013 17:26'!
userSpoke: userAndWords
	self triggerEvent: #userSpoke with: userAndWords.! !

Object subclass: #Room
	instanceVariableNames: 'roomSize attachedDevices name usersPresent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

Room class
	instanceVariableNames: 'noneRoom'!

Room class
	instanceVariableNames: 'noneRoom'!

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:48'!
createWithSize: aPoint 
	| room |
	room := Room new.
	room setSize: aPoint.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 21:15'!
createWithSize: aPoint withName: aName
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:45'!
initialize
	noneRoom := nil.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 17:47'!
noneRoom
	(noneRoom = nil) ifTrue: [ noneRoom := Room createWithSize: 0@0 withName: 'None' ].
	^ noneRoom.! !

!Room methodsFor: 'devices' stamp: 'CameronRieck 3/2/2013 15:41'!
addDevice: aDevice
	attachedDevices add: aDevice.! !

!Room methodsFor: 'users' stamp: 'CameronRieck 3/11/2013 13:13'!
addUser: aUser 
	usersPresent add: aUser.
	self triggerEvent: #userEntered with: aUser.
	aUser when: #userSpoke send: #userSpoke: to: self with: #userAndWords.! !

!Room methodsFor: 'devices' stamp: 'CameronRieck 3/6/2013 18:51'!
attachedDevices
	^ attachedDevices! !

!Room methodsFor: 'devices' stamp: 'CameronRieck 3/6/2013 18:51'!
devices
	^ attachedDevices! !

!Room methodsFor: 'devices' stamp: 'CameronRieck 3/3/2013 11:48'!
hasDevice: aDevice
	^ attachedDevices includes: aDevice! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/3/2013 12:14'!
height
	^ roomSize y! !

!Room methodsFor: 'users' stamp: 'CameronRieck 3/6/2013 20:02'!
includesUser: aUser 
	^ usersPresent includes: aUser.! !

!Room methodsFor: 'initialize-release' stamp: 'CameronRieck 3/6/2013 20:01'!
initialize
	attachedDevices := OrderedCollection new.
	usersPresent := Set new.! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/3/2013 11:58'!
length
	^ roomSize y! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/3/2013 11:54'!
name
	^ name! !

!Room methodsFor: 'devices' stamp: 'CameronRieck 3/9/2013 23:48'!
removeDevice: aDevice
	self triggerEvent: #deviceRemoved with: aDevice.
	(attachedDevices includes: aDevice) ifTrue: [ attachedDevices remove: aDevice ].
	! !

!Room methodsFor: 'users' stamp: 'CameronRieck 3/11/2013 17:41'!
removeUser: aUser
	self triggerEvent: #userExited with: aUser.
	aUser removeActionsWithReceiver: self.
	usersPresent remove: aUser.
	! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/3/2013 11:54'!
setName: aName
	name := aName.! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/2/2013 15:35'!
setSize: aPoint 
	roomSize := aPoint.! !

!Room methodsFor: 'users' stamp: 'CameronRieck 3/11/2013 11:10'!
userSpoke: userAndWords
	self triggerEvent: #userSpoke with: userAndWords.! !

!Room methodsFor: 'users' stamp: 'CameronRieck 3/9/2013 23:50'!
usersPresent
	^ usersPresent! !

!Room methodsFor: 'properties' stamp: 'CameronRieck 3/3/2013 11:58'!
width
	^ roomSize x! !

Object subclass: #User
	instanceVariableNames: 'name room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/10/2013 17:57'!
createWithName: aName 
	| newUser |
	newUser := User new.
	newUser name: aName.
	^ newUser.! !

!User methodsFor: 'actions' stamp: 'CameronRieck 3/11/2013 13:12'!
enterRoom: aRoom
	room := aRoom.
	room addUser: self.! !

!User methodsFor: 'actions' stamp: 'CameronRieck 3/11/2013 17:40'!
exitCurrentRoom
	room removeUser: self.
	self enterRoom: Room noneRoom.
	! !

!User methodsFor: 'initialize-release' stamp: 'CameronRieck 3/11/2013 17:31'!
initialize
	super initialize.
	self name: 'User'.
	self enterRoom: Room noneRoom.! !

!User methodsFor: 'properties' stamp: 'CameronRieck 3/7/2013 15:19'!
name
	^ name! !

!User methodsFor: 'properties' stamp: 'CameronRieck 3/6/2013 20:00'!
name: aName 
	name := aName.! !

!User methodsFor: 'properties' stamp: 'CameronRieck 3/10/2013 17:28'!
room
	^ room! !

!User methodsFor: 'actions' stamp: 'CameronRieck 3/11/2013 11:33'!
speak: words
	| userAndWords |
	userAndWords := (Association key: self value: words).
	self triggerEvent: #userSpoke with: userAndWords.! !
Room initialize!
